local delta,bullets,rotgoal,m,g,k,rot,img,mx,my,x,y,xvel,yvel,sp,lastshot,waitsp

--SOHCAHTOA

local function smooth(g, c, dt, speed)
    local pdiff = g - c + math.pi
    local diff = (pdiff) % (2 * math.pi) - math.pi
    if(math.abs(diff)==diff)then
        speed = math.max(0.7, speed * diff)
    else
        speed = math.max(0.7, speed * -diff)
    end

    if(diff > dt)then return c + (speed*dt) end
    if(diff < -dt)then return c - (speed*dt) end
    return g
end

local function shoot(tab, ang, speed, mx, my, x, y, w, h, cooldown)
    if(lastshot==0)then
        local bXvel = math.sin(ang)
        local bYvel = math.cos(ang)
        local sx = x + (115 * math.sin(ang) - (w/3))
        local sy = y + (115 * math.cos(ang) - (w/3))
        table.insert(tab, {x=sx,y=sy,r=r,xvel=bXvel,yvel=bYvel,w=w,h=h,speed=speed})
        lastshot = cooldown
    end
end

function love.load()
    m,g,k = love.mouse,love.graphics,love.keyboard
    g.setBackgroundColor(255,255,255)
    g.setDefaultFilter("nearest","nearest")
    rotgoal = {400,200}
    bullets = {}
    img = g.newImage("thing.png")
    sp = 4
    x,xvel = 400,0
    y,yvel = 200,0
    rot = 0
    lastshot = 0
    waitsp = 0
end

function love.update(dt)
    --updating title
    love.window.setTitle(math.deg(rot).." | "..#bullets.." | "..waitsp)
    lastshot = math.max(0, lastshot-dt)
    mx = m.getX()
    my = m.getY()
    x = x + (xvel * dt)
    y = y + (yvel * dt)
    rot = smooth(math.atan2(rotgoal[1]-x, rotgoal[2]-y), rot, dt, sp)
    if(k.isDown("left"))then
        rot = rot + (dt*5)
    end
    if(k.isDown("right"))then
        rot = rot - (dt*5)
    end
    if(k.isDown("w"))then
        yvel = -75
    end
    if(k.isDown("a"))then
        xvel = -75
    end
    if(k.isDown("d"))then
        xvel = 75
    end
    if(k.isDown("s"))then
        yvel = 75
    end
    if(k.isDown(" "))then
        shoot(bullets, rot, 300, mx, my, x, y, 5, 5, waitsp)
    end
    if(k.isDown("up"))then
        waitsp = waitsp + 0.0001
    end
    if(k.isDown("down"))then
        if(waitsp>0)then
            waitsp = waitsp - 0.0001
        else
            waitsp = 0
        end
    end
    for i,v in ipairs(bullets)do
        v.x = v.x + (v.xvel * (dt * v.speed))
        v.y = v.y + (v.yvel * (dt * v.speed))
        if(v.x>810 or v.y>610 or v.x<-10 or v.y<-10)then
            table.remove(bullets,i)
        end
    end
end

function love.mousepressed(mx, my, button)
    rotgoal = {mx, my}
end

function love.keyreleased(k)
    if(k=="a" or k=="d")then
        xvel = 0
    end
    
    if(k=="w" or k=="s")then
        yvel = 0
    end
end


function love.draw()
    g.setColor(50,50,50)
    for i,v in ipairs(bullets)do
        g.rectangle("fill", v.x, v.y, 4, 4)
    end
    g.setColor(255,0,0)
    g.circle("fill", rotgoal[1], rotgoal[2], 2)
    g.setColor(255,255,255)
    g.draw(img, x, y, -rot, 3, 3, img:getWidth()/2)
end
